//Class library for XBee S2 data transfer on API mode
//aoi shimada aoi480nm@gmail.com 2011-11-03 
//aoi shimada aoiimomushi@gmail.com 2013-02-26 
//Copyright (c)  2013 aoi shimada aoi480nm@gmail.com

using System;
using System.Collections.Generic;
using System.Text;
using System.IO.Ports;

namespace datasend_api
{
    public class send_api
    {
        //Class library for XBee S2 data transfer on API mode
        //aoi shimada aoi480nm@gmail.com 2011-11-03 
        //aoi shimada aoiimomushi@gmail.com 2013-02-26 
        //Copyright (c)  2013 aoi shimada aoi480nm@gmail.com

        private SerialPort prt_t;
        public SerialPort prt
        {
            set { prt_t = prt; }
            get { return prt_t; }
        }

        public send_api(SerialPort port) {
            prt_t = port;
        }

        public int datasend(String AddressH, String AddressL, char[] data)
        {
            byte[] send = new byte[512];

            uint idata = 0;
            int i=0;
            int j=0;

            uint address_h;
            uint address_l;

            address_h = UInt32.Parse(AddressH, System.Globalization.NumberStyles.HexNumber);
            address_l = UInt32.Parse(AddressL, System.Globalization.NumberStyles.HexNumber);

            //start delimiter
            send[0] = 0x7e;
            //length
            send[1] = 0x00;
            send[2] = (byte)(14 + data.Length);

            ////api-id
            //api-frame-type
            send[3] = 0x10;
            
            ////no-ack
            //frame-id
            send[4] = 0x01;

            send[5] = (byte)(address_h >> 24);
            send[6] = (byte)(address_h >> 16);
            send[7] = (byte)(address_h >> 8);
            send[8] = (byte)address_h;

            send[9] = (byte)(address_l >> 24);
            send[10] = (byte)(address_l >> 16);
            send[11] = (byte)(address_l >> 8);
            send[12] = (byte)address_l;

            //disable ack
            send[13] = 0xff;
            send[14] = 0xfe;

            //broadcast radius
            send[15] = 0x00;

            //options
            send[16] = 0x00;


            //rf data
            i = 17;
            for (j = 0; j < data.Length; j++)
            {
                send[i] = (byte)data[j];
                i++;
            }


            idata = 0;
            for (i = 3; i <= (16 + data.Length); i++)
            {
                idata = idata + (uint)send[i];
            }

            idata &= 0x0000ff;

            idata = 0xff - idata;

            send[i] = (byte)idata;

            try
            {
                prt_t.Write(send, 0, (18 + data.Length));
            }
            catch (Exception d){ }

            return 0;
        }
    }
}
